local lib = LibStub:NewLibrary("LibGuildBankScan", "1.0")
if not lib then return nil end
local strformat, match = string.format, strmatch
local MAX_GUILDBANK_SLOTS_PER_TAB = MAX_GUILDBANK_SLOTS_PER_TAB or 98
local slotItems = {}

local function scanGuild()
    wipe(slotItems)
    local numTabs = GetNumGuildBankTabs()
    local index = 0
    for tab = 1, numTabs do
        local _, _, isViewable, _, _, _ = GetGuildBankTabInfo(tab)
        if isViewable then
            for slot = 1, MAX_GUILDBANK_SLOTS_PER_TAB do
                local link = GetGuildBankItemLink(tab, slot)
                if link and lib:linkMatch(link) then
                    index = index + 1
                    local _, count = GetGuildBankItemInfo(tab, slot)
                    count = (count > 1 and count) or nil
                    if count then
                        slotItems[index] = strformat('%s,%d', lib:linkMatch(link), count)
                    else
                        slotItems[index] = lib:linkMatch(link)
                    end
                end
            end
        end
    end
end

lib.eventFrame = lib.eventFrame or CreateFrame("Frame")
lib.eventFrame:RegisterEvent("GUILDBANKBAGSLOTS_CHANGED")
lib.eventFrame:SetScript("OnEvent", scanGuild)

function lib:linkMatch(link)
    if not link then return nil end
    return link:match('|Hitem:(%d+):[%d:]+|h%[(.-)%]|h')
end

function lib:scanResult(itemid)
    local total = 0
    local _, link, _, _, _, _, _, _, _, _, _ = GetItemInfo(itemid)
    local id = lib:linkMatch(link)
    for _, item in pairs(slotItems) do
        local slotlink, slotcount = strsplit(',', item)
        if slotlink and slotlink == id then
            total = total + (slotcount or 1)
        end
    end
    return total
end








